unit _11ClientUnit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ScktComp;

const
  mGetInterval = 2;
  mSetInterval = 4;

type
  TF_Client = class(TForm)
    Client: TClientSocket;
    ProgBar: TProgressBar;
    Label1: TLabel;
    Edit1: TEdit;
    Label2: TLabel;
    procedure ClientRead(Sender: TObject; Socket: TCustomWinSocket);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    LowInterval: integer;
    HighInterval: integer;
    Readed: boolean;
    KnownPrime: array of integer;
    RPrime: array of integer;
    procedure MakeInterval;
//    procedure GetPrimeNum(HPos: integer);
  end;

var
  F_Client: TF_Client;

implementation

{$R *.DFM}
{
procedure TF_Client.GetPrimeNum(HPos: integer);
var
  A: array[0..1] of integer;
begin
  A[0]:= mGetInterval;
  A[1]:= HPos;
  while Client.Socket.SendBuf(A,SizeOf(integer)*2) = -1 do Sleep(100);
  Readed:= false;
  repeat
    Application.ProcessMessages;
  until Readed;
end;
      }
procedure TF_Client.MakeInterval;
var
//  HPos: integer;
  I, J: integer;
  R:  boolean;
begin
{  HPos:= Trunc(Sqrt(HighInterval));
  GetPrimeNum(HPos);
  for I:= LowInterval to HighInterval do
  begin
    R:= true;
    for J:= Low(KnownPrime) to High(KnownPrime) do
    if  I mod J = 0 then
    begin
      R:= false;
      Break;
    end;
    if R then
    begin
      SetLength(RPrime,Length(RPrime)+1);
      RPrime[High(RPrime)]:= I;
    end;
  end;  }
  if LowInterval < 2 then LowInterval:= 2;
  for I:= LowInterval to HighInterval do
  begin
    R:= true;
    for J:= 2 to Trunc(Sqrt(I)) do
    if I mod J = 0 then
    begin
      R:= false;
      Break;
    end;
    if R then
    begin
      SetLength(RPrime,Length(RPrime)+1);
      RPrime[High(RPrime)]:= I;
    end;
    ProgBar.Position:= Trunc((I /(HighInterval - LowInterval))*100);
  end;
end;

procedure TF_Client.ClientRead(Sender: TObject; Socket: TCustomWinSocket);
var
  Count: integer;
  A: array[0..500] of integer;
  I: integer;
begin
  Count:= Client.Socket.ReceiveLength;
  Client.Socket.ReceiveBuf(A,Count);
  if A[0] = mSetInterval then
  begin
    if Count < SizeOf(integer)*3 then raise Exception.Create('NotAllDataSended');
    LowInterval:= A[1];
    HighInterval:= A[2];
    MakeInterval;
    I:= Client.Socket.SendBuf(RPrime,Length(RPrime)*4);
    if I = -1 then ShowMessage('Errror');
  end else
  if A[0] = mGetInterval then
  begin

  end;
end;

procedure TF_Client.FormCreate(Sender: TObject);
begin
  Client.Open;
end;

end.
